//////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
//  Copyright Syncfusion Inc. 2001 - 2003. All rights reserved. Use of this code is subject to the terms of our 
//  license. A copy of the current license can be obtained at any time by e-mailing licensing@syncfusion.com. 
//  Re-distribution in any form is strictly prohibited. Any infringement will be prosecuted under applicable laws. 
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
 
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Runtime.Serialization;

using Syncfusion.Drawing;
using Syncfusion.Windows.Forms.Grid;

namespace CellButtons
{
	public class Form1 : System.Windows.Forms.Form
	{
		private GridControl gridControl1;

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			gridControl1.CellModels.Add("DragButton", new DragButtonCellModel(gridControl1.Model));

			int rowIndex;
			for (rowIndex = 3; rowIndex < 10; rowIndex += 2)
			{
				gridControl1[rowIndex, 1].Text = "Press and Drag Button";
				gridControl1[rowIndex, 3].CellType = "DragButton";
				gridControl1.CoveredRanges.Add(GridRangeInfo.Cells(rowIndex, 1, rowIndex, 2));
			}

			gridControl1.CellModels.Add("EllipsisText", new EllipsisCellModel(gridControl1.Model));
			for (rowIndex = 3; rowIndex < 10; rowIndex += 2)
			{
				gridControl1[rowIndex, 5].Text = "Browse Me";
				gridControl1[rowIndex, 5].CellType = "EllipsisText";
			}
			gridControl1.ColWidths.ResizeToFit(GridRangeInfo.Cells(3, 5, 10, 5));

			this.gridControl1.TableStyle.ReadOnly = true;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridControl1
			// 
			this.gridControl1.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.gridControl1.BackColor = System.Drawing.Color.AliceBlue;
			this.gridControl1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.gridControl1.ColCount = 15;
			this.gridControl1.Dock = System.Windows.Forms.DockStyle.None;
			this.gridControl1.HorizontalThumbTrack = true;
			this.gridControl1.Location = new System.Drawing.Point(32, 40);
			this.gridControl1.Name = "gridControl1";
			this.gridControl1.RowCount = 25;
			this.gridControl1.Size = new System.Drawing.Size(498, 297);
			this.gridControl1.TabIndex = 1;
			this.gridControl1.Text = "gridControl1";
			this.gridControl1.ThemesEnabled = true;
			this.gridControl1.VerticalThumbTrack = true;
			this.gridControl1.CellButtonClicked += new Syncfusion.Windows.Forms.Grid.GridCellButtonClickedEventHandler(this.gridControl1_CellButtonClicked);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(560, 374);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.gridControl1});
			this.Name = "Form1";
			this.Text = "Customized Cell Buttons";
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		public static void Main() 
		{
			Application.Run(new Form1());
		}

		private void gridControl1_CellButtonClicked(object sender, GridCellButtonClickedEventArgs e)
		{
			GridRangeInfo rg = GridRangeInfo.Cell(e.RowIndex, e.ColIndex);
			if (e.ColIndex == 5)
			{
				MessageBox.Show("Clicked " + e.ButtonIndex.ToString() + " button at " + rg.ToString() );
				 
			}
		}
	}
}
